<?php

namespace CustomerManagement\ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfPanelVersionEnum ArrayType
 * @subpackage Arrays
 */
class ArrayOfPanelVersionEnum extends AbstractStructArrayBase
{
    /**
     * The PanelVersionEnum
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var string[]
     */
    public $PanelVersionEnum;
    /**
     * Constructor method for ArrayOfPanelVersionEnum
     * @uses ArrayOfPanelVersionEnum::setPanelVersionEnum()
     * @param string[] $panelVersionEnum
     */
    public function __construct(array $panelVersionEnum = array())
    {
        $this
            ->setPanelVersionEnum($panelVersionEnum);
    }
    /**
     * Get PanelVersionEnum value
     * @return string[]|null
     */
    public function getPanelVersionEnum()
    {
        return $this->PanelVersionEnum;
    }
    /**
     * This method is responsible for validating the values passed to the setPanelVersionEnum method
     * This method is willingly generated in order to preserve the one-line inline validation within the setPanelVersionEnum method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validatePanelVersionEnumForArrayConstraintsFromSetPanelVersionEnum(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfPanelVersionEnumPanelVersionEnumItem) {
            // validation for constraint: enumeration
            if (!\CustomerManagement\EnumType\PanelVersionEnum::valueIsValid($arrayOfPanelVersionEnumPanelVersionEnumItem)) {
                $invalidValues[] = is_object($arrayOfPanelVersionEnumPanelVersionEnumItem) ? get_class($arrayOfPanelVersionEnumPanelVersionEnumItem) : sprintf('%s(%s)', gettype($arrayOfPanelVersionEnumPanelVersionEnumItem), var_export($arrayOfPanelVersionEnumPanelVersionEnumItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('Invalid value(s) %s, please use one of: %s from enumeration class \CustomerManagement\EnumType\PanelVersionEnum', is_array($invalidValues) ? implode(', ', $invalidValues) : var_export($invalidValues, true), implode(', ', \CustomerManagement\EnumType\PanelVersionEnum::getValidValues()));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set PanelVersionEnum value
     * @uses \CustomerManagement\EnumType\PanelVersionEnum::valueIsValid()
     * @uses \CustomerManagement\EnumType\PanelVersionEnum::getValidValues()
     * @throws \InvalidArgumentException
     * @param string[] $panelVersionEnum
     * @return \CustomerManagement\ArrayType\ArrayOfPanelVersionEnum
     */
    public function setPanelVersionEnum(array $panelVersionEnum = array())
    {
        // validation for constraint: array
        if ('' !== ($panelVersionEnumArrayErrorMessage = self::validatePanelVersionEnumForArrayConstraintsFromSetPanelVersionEnum($panelVersionEnum))) {
            throw new \InvalidArgumentException($panelVersionEnumArrayErrorMessage, __LINE__);
        }
        $this->PanelVersionEnum = $panelVersionEnum;
        return $this;
    }
    /**
     * Add item to PanelVersionEnum value
     * @uses \CustomerManagement\EnumType\PanelVersionEnum::valueIsValid()
     * @uses \CustomerManagement\EnumType\PanelVersionEnum::getValidValues()
     * @throws \InvalidArgumentException
     * @param string $item
     * @return \CustomerManagement\ArrayType\ArrayOfPanelVersionEnum
     */
    public function addToPanelVersionEnum($item)
    {
        // validation for constraint: enumeration
        if (!\CustomerManagement\EnumType\PanelVersionEnum::valueIsValid($item)) {
            throw new \InvalidArgumentException(sprintf('Invalid value(s) %s, please use one of: %s from enumeration class \CustomerManagement\EnumType\PanelVersionEnum', is_array($item) ? implode(', ', $item) : var_export($item, true), implode(', ', \CustomerManagement\EnumType\PanelVersionEnum::getValidValues())), __LINE__);
        }
        $this->PanelVersionEnum[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return string|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return string|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return string|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return string|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return string|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Add element to array
     * @see AbstractStructArrayBase::add()
     * @throws \InvalidArgumentException
     * @uses \CustomerManagement\EnumType\PanelVersionEnum::valueIsValid()
     * @param string $item
     * @return \CustomerManagement\ArrayType\ArrayOfPanelVersionEnum
     */
    public function add($item)
    {
        // validation for constraint: enumeration
        if (!\CustomerManagement\EnumType\PanelVersionEnum::valueIsValid($item)) {
            throw new \InvalidArgumentException(sprintf('Invalid value(s) %s, please use one of: %s from enumeration class \CustomerManagement\EnumType\PanelVersionEnum', is_array($item) ? implode(', ', $item) : var_export($item, true), implode(', ', \CustomerManagement\EnumType\PanelVersionEnum::getValidValues())), __LINE__);
        }
        return parent::add($item);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string PanelVersionEnum
     */
    public function getAttributeName()
    {
        return 'PanelVersionEnum';
    }
}
